/***************************************************************************
                          cdl.h  -  description
                             -------------------
    begin                : Wed Oct 3 2001
    copyright            : (C) 2001 by Dannel Albert
    email                : dalbert@capitol-college.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _CDL_H_
#define _CDL_H_

#include <iostream>
#include <string>
#include "globals.h"

class CanonicalDecimalList
{
private:
	unsigned int numInputs;
	unsigned int numCares;
	unsigned int numDontCares;
	
	std::string* inputs;
	unum* cares;
	unum* dontCares;
	
public:
	// CONSTRUCTOR / DESTRUCTOR
	CanonicalDecimalList();
	~CanonicalDecimalList();
	
	// ACCESSORS
	unsigned int GetNumInputs() const { return numInputs; }
	unsigned int GetNumCares() const { return numCares; }
	unsigned int GetNumDontCares() const { return numDontCares; }
	unum* GetCares(unsigned int& careSize) const
	{
	  careSize = numCares;
	  return cares;
	}
	
	unum* GetDontCares(unsigned int& dontCareSize) const
	{
	  dontCareSize = numDontCares;
	  return dontCares;
	} 	
	
	std::string* GetInputs(unsigned int& inputSize) const
	{
	  inputSize = numInputs;
	  return inputs;
	}
	
	friend std::ostream& operator<<(std::ostream& outs, const CanonicalDecimalList& cl);
	friend std::istream& operator>>(std::istream& ins, CanonicalDecimalList& cl);
};

std::ostream& operator<<(std::ostream& outs, const CanonicalDecimalList& cl);
std::istream& operator>>(std::istream& ins, CanonicalDecimalList& cl);

#endif