/***************************************************************************
                          mccluskey.h  -  description
                             -------------------
    begin                : Sat Oct 6 2001
    copyright            : (C) 2001 by Dannel Albert
    email                : dalbert@capitol-college.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _MCCLUSKEY_H_
#define _MCCLUSKEY_H_

#include <iostream>
#include "globals.h"
#include "quine.h"
#include "unumstack.h"

class McCluskey
{
private:
  CanonicalDecimalList* cdl;
  Quine* q;
  QuineGroup** primeImplicants;
  unsigned int numPI;
  bool** piTable;
  UNumStack imp;
  std::string booleanEq;
  unum* implicants;
  unsigned int numImplicants;

public:
  McCluskey(Quine* qq);
  ~McCluskey();

  void Solve();

  friend std::ostream& operator<<(std::ostream& outs, const McCluskey& mc);

private:
  void FewestImplicants();
  void CreateBooleanEquation();
};

std::ostream& operator<<(std::ostream& outs, const McCluskey& mc);

#endif