/***************************************************************************
                          quinelist.cpp  -  description
                             -------------------
    begin                : Sat Oct 6 2001
    copyright            : (C) 2001 by Dannel Albert
    email                : dalbert@capitol-college.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "quinelist.h"

using namespace std;

QuineList::QuineList(QuineList* n, QuineList* p)
{
  head = tail = NULL;
  next = n;
  prev = p;
  numTerms = 0;
  hasCombined = false;
}

QuineList::~QuineList()
{
  QuineTerm* qt = head;
  QuineTerm* trash;
  while (qt != NULL)
  {
    trash = qt;
    qt = qt->GetNext();
    delete trash;
  }

  next = prev = NULL;
  head = tail = NULL;
  numTerms = 0;
  hasCombined = false;
}

void QuineList::Insert(QuineTerm* qt)
{
  if (!numTerms)
  {
    head = tail = qt;
  }
  else
  {
    tail->SetNext(qt);
    qt->SetPrev(tail);
    tail = qt;
  }

  numTerms++;
}

QuineTerm* QuineList::TermAt(unsigned int index) const
{
  if (index > numTerms)
    return NULL;

  QuineTerm* qt = head;
  for(unsigned int i=0; i<index; i++)
    qt = qt->GetNext();

  return qt;
}

ostream& operator<<(ostream& outs, const QuineList& ql)
{
  QuineTerm* qt = ql.head;
  for(unsigned int i=0; i<ql.numTerms; i++)
  {
    outs << *qt;
    if (i != ql.numTerms-1)
      outs << "----" << endl;
    qt = qt->GetNext();
  }
  return outs;
}