/***************************************************************************
                          quineterm.h  -  description
                             -------------------
    begin                : Sat Oct 6 2001
    copyright            : (C) 2001 by Dannel Albert
    email                : dalbert@capitol-college.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _QUINETERM_H_
#define _QUINETERM_H_

#include <iostream>
#include "quinegroup.h"

// *** NOTE ***
// Although QuineGroups are not created by the QuineTerm class,
// the QuineTerm class will delete all QuineGroups it contains
// when the QuineTerm destructor is called.
class QuineTerm
{
private:
  QuineGroup* head;
  QuineGroup* tail;
  QuineTerm* next;
  QuineTerm* prev;
  unsigned int numGroups;

public:
  // CONSTRUCTORS
  QuineTerm(QuineTerm* n=NULL, QuineTerm* p=NULL);
  ~QuineTerm();

  // ACCESSORS
  QuineTerm* GetNext() const { return next; }
  QuineTerm* GetPrev() const { return prev; }
  unsigned int Size() const { return numGroups; }

  // MODIFIERS
  void SetNext(QuineTerm* n) { next = n; }
  void SetPrev(QuineTerm* p) { prev = p; }

  void Insert(QuineGroup *qg);
  QuineGroup* GroupAt(unsigned int index) const;

  friend std::ostream& operator<<(std::ostream& outs, const QuineTerm& qt);

private:
  QuineGroup* FindGreaterThan(unum n);
};

std::ostream& operator<<(std::ostream& outs, const QuineTerm& qt);

#endif