/***************************************************************************
                          strstack.cpp  -  description
                             -------------------
    begin                : Wed Oct 3 2001
    copyright            : (C) 2001 by Dannel Albert
    email                : dalbert@capitol-college.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cassert>
#include "strstack.h"

using namespace std;

StrStack::StrStack()
{
  numItems = 0;
  top = NULL;
}

StrStack::~StrStack()
{
  StrNode* nd;
  for(unsigned int i=0; i<numItems; i++)
  {
    nd = top;
    top->SetNext(top->GetNext());
    delete nd;
  }
}

string StrStack::Peek() const
{
  if (numItems == 0)
    return (string)"";
  return top->GetData();
}

string StrStack::Pop()
{
  string data;
  if (numItems == 0)
    return (string)"";

  StrNode* nd = top;
  data = nd->GetData();
  top = top->GetNext();
  delete nd;
  numItems--;
  return data;
}

void StrStack::Push(string s)
{
  StrNode* nd = new StrNode(s, top);
  assert(nd);
  top = nd;
  numItems++;
}