/***************************************************************************
                          unumstack.cpp  -  description
                             -------------------
    begin                : Wed Oct 3 2001
    copyright            : (C) 2001 by Dannel Albert
    email                : dalbert@capitol-college.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cassert>
#include "unumstack.h"

UNumStack::UNumStack()
{
  numItems = 0;
  top = NULL;
}

UNumStack::~UNumStack()
{
  UNumNode* trash;
  while (top != NULL)
  {
    trash = top;
    top = top->GetNext();
    delete trash;
  }

  top = NULL;
  numItems = 0;
}

unum UNumStack::Peek() const
{
  if (numItems == 0)
    return (unum)-1;
  return top->GetData();
}

unum UNumStack::Pop()
{
  unum data;
  assert(numItems != 0);

  UNumNode* nd = top;
  data = nd->GetData();
  top = top->GetNext();
  delete nd;
  numItems--;
  return data;
}

void UNumStack::Push(unum i)
{
  UNumNode* nd = new UNumNode(i, top);
  assert(nd);
  top = nd;
  numItems++;
}